# _*_ coding: UTF-8 _*_
import os
import gitpy
import Molho.settings as settings
from django.db import models
from django.contrib.auth.models import User

class Git:
    def __init__(self, git_repo = settings.git_repo):
        if not os.path.exists(os.path.join(settings.git_path,".git")):
            gitpy.clone(git_repo, settings.git_path)

        self.repo = gitpy.LocalRepository(settings.git_path)

    def save_state(self, name):
        self.update()
        self.repo.add(name)
        self.repo.commit("[molho] alterando %s"  % name)
        self.repo.push()

    def _touch_keys_path(self):
        if not os.path.exists(settings.keys_path):
            os.mkdir(settings.keys_path)

    def update(self):
        self._touch_keys_path()
        self.repo.pull()

    def push(self):
        self.repo.push()


class Secret:

    def __init__(self, git, name , content = ''):
        self.name = name
        self.content = content
        self.git = git

    def get_content(self):
        return open(os.path.join(settings.keys_path,self.name), "r").read()
            
    def set_content(self, data):
        open(os.path.join(settings.keys_path,self.name), "w").write(data)

    content = property(get_content, set_content)

    def template_entry(self):
        template = "{'name':'%s','content':'%s'}" %(self.name, '') 
        fd = open(os.path.join(settings.keys_path,self.name),"w")
        fd.write(template)
        fd.close()
        self.content = template

    def __unicode__(self):
        return self.name

class Library:

    def __init__(self, git):
        self.git = git
    
    def list_keys(self):
        keys = []
        for key in os.listdir(settings.keys_path):
            if not key.startswith("."):
                keys.append(Secret(self.git, key))

        return keys

    def get_all_data(self):
        datas = []
        for data in self.list_keys():
            datas.append(data.get_content())

        return datas


